<template>
  <div
    @click="authenticated ? handleGameClick(gameForDisplay) : toggleLoginRegisterDialog()"
    class="w-full relative">
    <div class="flex flex-col absolute left-1 top-1 items-start gap-1 z-30">
      <div v-if="!gameForDisplay.IsHotGame" class="w-8 h-[11.2px]">
        <img
          class="w-full h-full"
          src="assets/images/sports/category_tags.png"
        />
      </div>
      <div v-if="!gameForDisplay.IsNewGame" class="w-8 h-[11.2px]">
        <img
          class="w-full h-full"
          src="assets/images/sports/category_tag_new.png"
        />
      </div>
    </div>
    <div class="w-full h-auto relative">
      <div class="w-full relative h-[90.85px] z-20 mt-[38px] border-[1px] border-[#4D5080] rounded-lg bg-background5">
        <div class="relative h-full w-full bg-background5 rounded-lg overflow-hidden">
            <img
              class="absolute w-full h-full object-cover"
              src="assets/images/sports/football-stadium-background.png" />
            <img
                class="w-[110px]"
                src="assets/images/sports/bg_effect_product_category_loby.png"/>
        </div>
        <div class="w-full m-auto z-30 absolute -top-9 flex items-center">
            <img
              :src="gameForDisplay.StarImagePath"
              class="w-full h-full m-auto object-contain"
              @error="
              (e) =>
                  isHandleDefaultImageRender(gameForDisplay.StarImagePath)
                    ? onErrorDefaultImage(e, gameForDisplay.StarImagePath)
                    : e.target.remove()
              "
            />
          </div>
        <div class="fading-bg h-[36px] w-full z-40 absolute bottom-0 rounded-lg" />
        <div class="w-full items-center justify-center absolute bottom-1 m-auto z-40">
          <div class="flex items-center justify-center w-[75.7px] h-[30.85px] m-auto p-[2.85px]">
            <img
              :src="gameForDisplay.ProviderLogoCenterPath"
              class="h-full w-full object-contain"
              @error="(e) => e.target.remove()"
            />
          </div>
        </div>
        <div class="absolute w-full z-10 -top-10">
          <img
            class="h-[96px] w-[94px] m-auto object-contain"
            src="assets/images/sports/background-product-category-deco.png"/>
        </div>
      </div>
      <div
        v-if="isMultipleProvider"
        class="flex items-center w-full mt-1 justify-center">
        <span class="game-name align-middle">{{ gameForDisplay.GameName }}</span>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import CockFightDisplayModel from "~~/models/cockFightModel";
import { IGame } from "@/models/IGetPlayableGamesResponse";
import SportDisplayModel from "~~/components/sport/sportDisplayModel";

export default defineComponent({
  props: {
    game: {
      type: Object as PropType<IGameBsi>,
      required: true,
    },
    isMultipleProvider: {
      type: Boolean,
      required: true,
    },
  },
  setup(props) {
    const authenticated = computed(() => store.state.auth);
    const { getAssetImage, onErrorDefaultImage, isHandleDefaultImageRender, toggleLoginRegisterDialog } = commonHelper;
    const gameForDisplay = computed(() => new SportDisplayModel(props.game));
    const config = useRuntimeConfig();
    const router = useRouter();
    const route = useRoute();
    const handleGameClick = (game: IGame) => {
      const isDemo = config.public.CURRENTLY_ENV === "demo";
      const isWebId8 = store.state.webId === 8;
      const isSportPage = route.path.includes("/sports");
      const isMainTheme = store.state.selectedThemeName === "main";
      if (isDemo && isWebId8 && isSportPage && isMainTheme) {
        const location = EnumEntranceLocation.GameLobby;
        router.push(`/game/${game.GameId}?location=${location}&silent`);
      } else {
        handleGameEntryOpenWindow(game, 550, 850);
      }
    };
    const getCockFightBackgroundMobileImage = (game: IGameBsi) => {
      const imageForDisplay = computed(() => new CockFightDisplayModel(game));
      const startImage = imageForDisplay.value.backgroundMobilePath;
      return startImage;
    }
    return {
      authenticated,
      getAssetImage,
      gameForDisplay,
      handleGameEntryOpenWindow,
      onErrorDefaultImage,
      isHandleDefaultImageRender,
      handleGameClick,
      toggleLoginRegisterDialog,
      getCockFightBackgroundMobileImage,
    };
  },
});
</script>

<style scoped>
.fading-bg {
  background: linear-gradient(0deg, #0B0E30 41.89%, rgba(11, 14, 48, 0) 100%);
}
.game-name {
  font-family: Roboto;
  font-size: 12px;
  font-weight: 700;
  line-height: 14.06px;
  text-align: center;
  color: var(--text2);
}
</style>
